; MATH.ASM
; part of Ben's Command Extender
; misc. math procs
; 5 Dec 97
; blm
;


; count
; count up from arg1
count:
	
	mov     ax, string
	call    nextarg     ; skip arg0
	call    nextarg
	call    strlen
	and     ax, ax
	je      .no_change
	mov		ax, string
	call    atou
	mov     [cs:count_value], ax
	mov		ax, string
	call    nextarg
	call    strlen
	and     ax, ax
	je      .no_change
	mov		ax, string
	call    atou
	mov     [cs:inc_value], ax
.no_change:
	mov     ax, [cs:count_value]
	call    [cs:show_num]
	call    [cs:new_line]
	add     ax, [cs:inc_value]
	mov     [cs:count_value], ax

	dec		ax			; return count as errorlevel
	ret
	
	
	
; add
; add the values arg1 and arg2
addition:
	push    cx
	
	mov		ax, string
	call    nextarg     ; skip arg0
	call    nextarg
	call    atou
	mov     cx, ax
	mov		ax, string
	call    nextarg
	mov		ax, string
	call    atou
	add     ax, cx
	call    [cs:show_num]
	call    [cs:new_line]
		
	pop     cx
	ret
	
	
	
; sub
; subtract arg1 from arg2
subtraction:
	push    cx
	
	mov		ax, string
	call    nextarg     ; skip arg0
	call    nextarg
	call    atou
	mov     cx, ax
	mov		ax, string
	call    nextarg
	call    atou
	xchg    ax, cx
	sub     ax, cx
	call    [cs:show_num]
	call    [cs:new_line]
		
	pop     cx
	ret
	
	
	
; div
; dived arg1 by arg 2
division:
	push    bx
	push    dx
	
	xor     dx, dx
	mov		ax, string
	call    nextarg     ; skip arg0
	call    nextarg
	call    strlen
	and     ax, ax
	jz      .done
	mov		ax, string
	call    atou
	mov     bx, ax
	mov		ax, string
	call    nextarg
	call    atou
	and     ax, ax
	jz      .done
	xchg    ax, bx
	div     bx

.done:
	call    [cs:show_num]
	call    [cs:new_line]
	
	pop     dx
	pop     bx
	ret



; mod
; return modulous of arg1 and arg 2
modulous:
	push    bx
	push    dx
	
	xor     dx, dx
	mov		ax, string
	call    nextarg     ; skip arg0
	call    nextarg
	call    strlen
	and     ax, ax
	jz      .done
	mov		ax, string
	call    atou
	mov     bx, ax
	mov		ax, string
	call    nextarg
	call    atou
	and     ax, ax
	jz      .done
	xchg    ax, bx
	div     bx

.done:
	mov     ax, dx
	call    [cs:show_num]
	call    [cs:new_line]
	
	pop     dx
	pop     bx
	ret

	
	
	
; mul
; multiply arg1 and arg2
multiplication:
	push    bx
	push    dx
	
	xor     dx, dx
	mov		ax, string
	call    nextarg     ; skip arg0
	call    nextarg
	call    atou
	mov     bx, ax
	mov		ax, string
	call    nextarg
	call    atou
	xchg    ax, bx
	mul     bx

	call    [cs:show_num]
	call    [cs:new_line]
	
	pop     dx
	pop     bx
	ret


; math data
count_value     dw 0000h
inc_value       dw 0001h
